Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 2528)
@@ -4,10 +4,10 @@
    !! Ocean physics: internal restoring trend on passive tracers
    !!======================================================================
-   !! History :  7.0  !         (G. Madec)  Original code
-   !!                 !  96-01  (G. Madec) 
-   !!                 !  97-05  (H. Loukos)  adapted for passive tracers
-   !!            8.5  !  02-08  (G. Madec )  free form + modules
-   !!            9.0  !  04-03  (C. Ethe)    free form + modules
-   !!                 !  07-02  (C. Deltel)  Diagnose ML trends for passive tracers
+   !! History :  OPA  !  1991-03  (O. Marti, G. Madec)  Original code
+   !!                 !  1996-01  (G. Madec) statement function for e3
+   !!                 !  1997-05  (H. Loukos)  adapted for passive tracers
+   !!    NEMO    9.0  !  2004-03  (C. Ethe)    free form + modules
+   !!            3.2  !  2007-02  (C. Deltel)  Diagnose ML trends for passive tracers
+   !!            3.3  !  2010-06  (C. Ethe, G. Madec) merge TRA-TRC 
    !!----------------------------------------------------------------------
 #if  defined key_top && defined key_trcdmp 
@@ -17,15 +17,12 @@
    !!   trc_dmp      : update the tracer trend with the internal damping
    !!   trc_dmp_init : initialization, namlist read, parameters control
-   !!   trccof_zoom  : restoring coefficient for zoom domain
-   !!   trccof       : restoring coefficient for global domain
-   !!   cofdis       : compute the distance to the coastline
    !!----------------------------------------------------------------------
    USE oce_trc         ! ocean dynamics and tracers variables
    USE trc             ! ocean passive tracers variables
-   USE trctrp_lec      ! passive tracers transport
+   USE trcnam_trp      ! passive tracers transport namelist variables
    USE trcdta
+   USE tradmp
    USE prtctl_trc      ! Print control for debbuging
-   USE trdmld_trc
-   USE trdmld_trc_oce     
+   USE trdtra
 
    IMPLICIT NONE
@@ -35,12 +32,20 @@
 
    LOGICAL , PUBLIC, PARAMETER ::   lk_trcdmp = .TRUE.   !: internal damping flag
-   REAL(wp), DIMENSION(jpi,jpj,jpk,jptra) ::   restotr   ! restoring coeff. on tracers (s-1)
+   !                             !!* Namelist namtrc_dmp : passive tracer newtonian damping *
+   INTEGER  ::   nn_hdmp_tr =   -1   ! = 0/-1/'latitude' for damping over passive tracer
+   INTEGER  ::   nn_zdmp_tr =    0   ! = 0/1/2 flag for damping in the mixed layer
+   REAL(wp) ::   rn_surf_tr =   50.  ! surface time scale for internal damping        [days]
+   REAL(wp) ::   rn_bot_tr  =  360.  ! bottom time scale for internal damping         [days]
+   REAL(wp) ::   rn_dep_tr  =  800.  ! depth of transition between rn_surf and rn_bot [meters]
+   INTEGER  ::   nn_file_tr =    2   ! = 1 create a damping.coeff NetCDF file 
+
+   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   restotr   ! restoring coeff. on tracers (s-1)
 
    !! * Substitutions
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   TOP 1.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Header: /home/opalod/NEMOCVSROOT/NEMO/TOP_SRC/TRP/trcdmp.F90,v 1.11 2006/09/01 14:03:49 opalod Exp $ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -66,26 +71,23 @@
       !!              - save the trends ('key_trdmld_trc')
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   ztrtrd => ua  ! use ua as 3D workspace   
       !!
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
+      !!
       INTEGER  ::   ji, jj, jk, jn       ! dummy loop indices
-      REAL(wp) ::   ztest, ztra !!!, zdt    ! temporary scalars
+      REAL(wp) ::   ztra                 ! temporary scalars
       CHARACTER (len=22) :: charout
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
       !!----------------------------------------------------------------------
 
       ! 0. Initialization (first time-step only)
       !    --------------
-      IF( kt == nittrc000 ) CALL trc_dmp_init
-
+      IF( kt == nit000 ) CALL trc_dmp_init
+
+      IF( l_trdtrc )   ALLOCATE( ztrtrd(jpi,jpj,jpk) )   ! temporary save of trends
 
       ! 1. Newtonian damping trends on tracer fields
       ! --------------------------------------------
-      !    compute the newtonian damping trends depending on nmldmptr
-
-!!!      zdt  = rdt * FLOAT( ndttrc )
-
       ! Initialize the input fields for newtonian damping
-      CALL dta_trc( kt )
-
+      CALL trc_dta( kt )
       !                                                          ! ===========
       DO jn = 1, jptra                                           ! tracer loop
@@ -94,43 +96,30 @@
 
          IF( lutini(jn) ) THEN
-
-            SELECT CASE ( nmldmptr )
-
-            CASE( 0 )                ! newtonian damping throughout the water column
-
+            !
+            SELECT CASE ( nn_zdmp_trc )
+            !
+            CASE( 0 )                !==  newtonian damping throughout the water column  ==!
                DO jk = 1, jpkm1
                   DO jj = 2, jpjm1
                      DO ji = fs_2, fs_jpim1   ! vector opt.
-                        ztra = restotr(ji,jj,jk,jn) * ( trdta(ji,jj,jk,jn) - trb(ji,jj,jk,jn) )
-                        ! add the trends to the general tracer trends
-!!                        trn(ji,jj,jk,jn) = trn(ji,jj,jk,jn) + ztra * zdt
+                        ztra = restotr(ji,jj,jk) * ( trdta(ji,jj,jk,jn) - trb(ji,jj,jk,jn) )
                         tra(ji,jj,jk,jn) = tra(ji,jj,jk,jn) + ztra
                      END DO
                   END DO
                END DO
-
-            CASE ( 1 )                ! no damping in the turbocline (avt > 5 cm2/s)
+            !
+            CASE ( 1 )                !==  no damping in the turbocline (avt > 5 cm2/s)  ==!
                DO jk = 1, jpkm1
                   DO jj = 2, jpjm1
                      DO ji = fs_2, fs_jpim1   ! vector opt.
-                        ztest = avt(ji,jj,jk) - 5.e-4
-                        IF( ztest < 0. ) THEN
-                           ztra = restotr(ji,jj,jk,jn) * ( trdta(ji,jj,jk,jn) - trb(ji,jj,jk,jn) )
-                        ELSE
-                           ztra = 0.e0
+                        IF( avt(ji,jj,jk) <= 5.e-4 )  THEN 
+                           ztra = restotr(ji,jj,jk) * ( trdta(ji,jj,jk,jn) - trb(ji,jj,jk,jn) )
+                           tra(ji,jj,jk,jn) = tra(ji,jj,jk,jn) + ztra
                         ENDIF
-                        ! add the trends to the general tracer trends
-!!                        trn(ji,jj,jk,jn) = trn(ji,jj,jk,jn) + ztra * zdt
-                        tra(ji,jj,jk,jn) = tra(ji,jj,jk,jn) + ztra 
-#    if defined key_trc_diatrd
-                        ! save the trends for diagnostics
-                        IF (luttrd(jn)) trtrd(ji,jj,jk,ikeep(jn),jpdiatrc) = ztra
-#    endif
-
                      END DO
                   END DO
                END DO
-
-            CASE ( 2 )                ! no damping in the mixed layer 
+            !
+            CASE ( 2 )               !==  no damping in the mixed layer   ==! 
                DO jk = 1, jpkm1
                   DO jj = 2, jpjm1
@@ -138,39 +127,28 @@
                         IF( fsdept(ji,jj,jk) >= hmlp (ji,jj) ) THEN
                            ztra = restotr(ji,jj,jk,jn) * ( trdta(ji,jj,jk,jn) - trb(ji,jj,jk,jn) )
-                        ELSE
-                           ztra = 0.e0
-                        ENDIF
-                        ! add the trends to the general tracer trends
-!!                        trn(ji,jj,jk,jn) = trn(ji,jj,jk,jn) + ztra * zdt
-                        tra(ji,jj,jk,jn) = tra(ji,jj,jk,jn) + ztra
-#    if defined key_trc_diatrd
-                        ! save the trends for diagnostics
-                        IF (luttrd(jn)) trtrd(ji,jj,jk,ikeep(jn),jpdiatrc) = ztra
-#    endif
-
+                           tra(ji,jj,jk,jn) = tra(ji,jj,jk,jn) + ztra
+                        END IF
                      END DO
                   END DO
                END DO
-               
+            !  
             END SELECT
-
+            ! 
          ENDIF
-
+         !
          IF( l_trdtrc ) THEN
             ztrtrd(:,:,:) = tra(:,:,:,jn) -  ztrtrd(:,:,:)
-            IF (luttrd(jn)) CALL trd_mod_trc( ztrtrd, jn, jptrc_trd_dmp, kt )        ! trends diags.
+            CALL trd_tra( kt, 'TRC', jn, jptra_trd_dmp, ztrtrd )
          END IF
          !                                                       ! ===========
       END DO                                                     ! tracer loop
       !                                                          ! ===========
-
-      IF( ln_ctl ) THEN    ! print mean trends (used for debugging)
-         WRITE(charout, FMT="('dmp')")
-         CALL prt_ctl_trc_info( charout )
-         CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd' )
+      IF( l_trdtrc )  DEALLOCATE( ztrtrd )
+      !                                          ! print mean trends (used for debugging)
+      IF( ln_ctl )   THEN
+         WRITE(charout, FMT="('dmp ')") ;  CALL prt_ctl_trc_info(charout)
+                                           CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       ENDIF
-  
-      trb(:,:,:,:) = trn(:,:,:,:)
-   
+      !
    END SUBROUTINE trc_dmp
 
